{(c) 2000 ArrowSoft  Vlad Parcalabior
          vlad@ifrance.com
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gl, glu, glex, ExtCtrls, StdCtrls, ComCtrls;

type
  TMform = class(TForm)
    Timer1: TTimer;
    Timer2: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    TrackBar7: TTrackBar;
    TrackBar8: TTrackBar;
    TrackBar9: TTrackBar;
    TrackBar10: TTrackBar;
    TrackBar11: TTrackBar;
    TrackBar12: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    TrackBar13: TTrackBar;
    Label17: TLabel;
    Label18: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer2Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
    procedure TrackBar8Change(Sender: TObject);
    procedure TrackBar9Change(Sender: TObject);
    procedure TrackBar10Change(Sender: TObject);
    procedure TrackBar11Change(Sender: TObject);
    procedure TrackBar12Change(Sender: TObject);
    procedure TrackBar13Change(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
      matAmb1:Tvec4f = (0.7, 0.53, 0.3, 1.0); //ambient
      matDif1:Tvec4f = (0.76, 0.57, 0.16, 1.0); //diffuse
      matSpec1:Tvec4f = (1.0, 0.15, 0.0, 1.0); //specular
      matEm1:Tvec4f = (0.75, 0.588, 0.0, 1.0); //emission

      matAmb2:Tvec4f = (0.1, 0.1, 0.2, 1.0);
      matDif2:Tvec4f = (0.4, 0.74, 0.7, 1.0);
      matSpec2:Tvec4f = (1.0, 0.8, 0.7, 1.0);
      matEm2:Tvec4f = (0.0, 0.0, 0.0, 1.0);

      matAmb3:Tvec4f = (0.2, 0.2, 0.25, 1.0);
      matDif3:Tvec4f = (0.8, 0.8, 0.95, 1.0);
      matSpec3:Tvec4f = (0.3, 0.3, 1.0, 1.0);
      matEm3:Tvec4f = (0.0, 0.0, 0.0, 1.0);

var
  Mform: TMform;
  rotang:glfloat;
  conti:boolean;
  count:cardinal;
  vendor,renderer,dims:string;
  elapsedframetime, starttime:cardinal;
  shin:byte;
  rvx, rvy, inix, iniy: integer;
  rot: boolean;
implementation

{$R *.DFM}


procedure drawsphere(AngleX, radius:GLfloat; position:pTvec3f; TexID:byte; matAmb:Tvec4f; matDif:tvec4f;matSpec:tvec4f;matEm:tvec4f;shininess:GLfloat);
var sphere: pGLUquadricObj;

begin
glPushMatrix;
glTranslatef(Position[0], Position[1], Position[2]);
glRotatef(AngleX, 0.0, 0.0, 1.0);
glMaterialfv(GL_FRONT, GL_AMBIENT, @matAmb);
glMaterialfv(GL_FRONT, GL_DIFFUSE, @matDif);
glMaterialfv(GL_FRONT, GL_SPECULAR, @matSpec);
glMaterialfv(GL_FRONT, GL_EMISSION, @matEm);
glMaterialfv(GL_FRONT, GL_SHININESS, @shininess);
sphere := gluNewQuadric;
gluQuadricOrientation(sphere, GLU_OUTSIDE);
gluQuadricNormals(sphere, GLU_SMOOTH);

if texID>0 then
 begin
 glEnable(GL_TEXTURE_2D);
 glBindTexture(GL_TEXTURE_2D, TexID);
 gluQuadricTexture(sphere, GL_true);
 end;
gluSphere(sphere, Radius, 20, 20);
gluDeleteQuadric(sphere);
if glIsEnabled(GL_TEXTURE_2D) then glDisable(GL_TEXTURE_2D);
glPopMatrix;
end;

procedure drawscene;
var pos: tvec3f;
begin
starttime:=gettickcount;
glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

glpushmatrix;
 glRotatef(-rotang/7, 0.0, 0.0, 1.0);
 Pos[0]:=0.0; //x coordinate
 Pos[1]:=0.0; //y coordinate
 Pos[2]:=0.0; //z coordinate
 drawsphere(0,0.7,@pos,2,matAmb1,matDif1,matSpec1,matEm1,10); //Sun
glPopMatrix;

glPushMatrix;
 glRotatef(rotang, 0.0, 0.0, 1.0);
 Pos[0]:=-2;
 Pos[1]:=0.0;
 Pos[2]:=0.0;
 drawsphere(-rotang,0.4,@pos,1,matAmb2,matDif2,matSpec2,matEm2,shin);  //Earth

 glpushmatrix;
  glTranslatef(Pos[0], Pos[1], Pos[2]);
  glRotatef(rotang*2, 0, 1, 1);
  Pos[0]:=-0.6;
  Pos[1]:=0.0;
  Pos[2]:=0.0;
  drawsphere(0,0.1,@pos,3,matAmb3,matDif3,matSpec3,matEm3,10);  //moon
 glpopmatrix;

glPopMatrix;
glFinish;

SwapBuffers(DC);
elapsedframetime:=gettickcount-starttime;
end;


procedure inittextures;
var texture: TTexture;
    ptex: pointer;
begin
texture:=ttexture.Load(1,'earth.jpg');
glBindTexture(GL_TEXTURE_2D, texture.ID);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_linear);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_linear);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_modulate);
ptex:=texture.pixels;
glTexImage2D(GL_TEXTURE_2D, 0, 3, texture.width, texture.height,
                         0, GL_RGB, GL_UNSIGNED_BYTE, ptex^);
texture.Free;

texture:=ttexture.Load(2,'sun.jpg');
glBindTexture(GL_TEXTURE_2D, texture.ID);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_linear);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_linear);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_modulate);
ptex:=texture.pixels;
glTexImage2D(GL_TEXTURE_2D, 0, 3, texture.width, texture.height,
                         0, GL_RGB, GL_UNSIGNED_BYTE, ptex^);
texture.Free;

texture:=ttexture.Load(3,'ogl.jpg');
glBindTexture(GL_TEXTURE_2D, texture.ID);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_linear);
glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_linear);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_modulate);
ptex:=texture.pixels;
glTexImage2D(GL_TEXTURE_2D, 0, 3, texture.width, texture.height,
                         0, GL_RGB, GL_UNSIGNED_BYTE, ptex^);
texture.Free;

glmatrixmode(gl_texture);    //flip planet textures vertically
glRotatef(180, 0.0, 1.0, 0.0);
glmatrixmode(gl_modelview);
end;

procedure initlights;
const
   light0Ambient :tvec4f = (0.27, 0.23, 0.48, 1.0);
   light0Diffuse :tvec4f = (1.0, 1.0, 1.0, 1.0);
   light0Specular :tvec4f = (1.0, 1.0, 1.0, 1.0);
   light0Position :tvec4f = (0.0, 0.0, 0.0, 1.0);
begin
glLightfv(GL_LIGHT0, GL_AMBIENT, @light0Ambient);
glLightfv(GL_LIGHT0, GL_DIFFUSE, @light0Diffuse);
glLightfv(GL_LIGHT0, GL_SPECULAR, @light0Specular);
glLightfv(GL_LIGHT0, GL_POSITION, @light0Position);
glEnable(GL_LIGHT0);
end;


procedure TMform.FormCreate(Sender: TObject);
begin
initrc(panel1.Handle);
initgl(Width, Height);
renderer:=StrPas(PChar(glGetString(GL_renderer)));
vendor:=StrPas(PChar(glGetString(GL_vendor)));
glMatrixMode(GL_MODELVIEW);

glulookat(0,0,3,0,0,0,0,1,0);
glRotatef(120,1,0,0);
initlights; //light position is also rotated
inittextures;
with panel1 do
 begin
 trackbar1.Position:=round(matEm1[0]*255);
 trackbar2.Position:=round(matEm1[1]*255);
 trackbar3.Position:=round(matEm1[2]*255);
 label5.Caption:=inttostr(trackbar1.Position);
 label6.Caption:=inttostr(trackbar2.Position);
 label7.Caption:=inttostr(trackbar3.Position);

 trackbar4.Position:=round(matAmb2[0]*255);
 trackbar5.Position:=round(matAmb2[1]*255);
 trackbar6.Position:=round(matAmb2[2]*255);
 label8.Caption:=inttostr(trackbar4.Position);
 label9.Caption:=inttostr(trackbar5.Position);
 label10.Caption:=inttostr(trackbar6.Position);

 trackbar7.Position:=round(matDif2[0]*255);
 trackbar8.Position:=round(matDif2[1]*255);
 trackbar9.Position:=round(matDif2[2]*255);
 label11.Caption:=inttostr(trackbar7.Position);
 label12.Caption:=inttostr(trackbar8.Position);
 label13.Caption:=inttostr(trackbar9.Position);

 trackbar10.Position:=round(matSpec2[0]*255);
 trackbar11.Position:=round(matSpec2[1]*255);
 trackbar12.Position:=round(matSpec2[2]*255);
 label14.Caption:=inttostr(trackbar10.Position);
 label15.Caption:=inttostr(trackbar11.Position);
 label16.Caption:=inttostr(trackbar12.Position);
 end;
shin:=15;
angx:=0;angy:=0;
width:=640;height:=520;
timer1.Enabled:=true;
end;

procedure TMform.FormDestroy(Sender: TObject);
begin
releaserc(handle);
end;

procedure TMform.FormResize(Sender: TObject);
begin
dims:=inttostr(panel1.ClientWidth)+'/'+inttostr(panel1.ClientHeight);
resizeviewport(Width, Height);
end;

procedure Animate;
begin
repeat
 rotang:=rotang+(elapsedframetime*50)/1000; //50 degrees per second
 drawscene;
 inc(count);
 application.ProcessMessages;
until not conti;
end;

procedure TMform.Timer1Timer(Sender: TObject);
begin
conti:=true;
count:=0;
timer1.Enabled:=false;
Animate;
end;

procedure TMform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
conti:=false;
end;

procedure TMform.Timer2Timer(Sender: TObject);
begin
mform.Caption:='Renderer: '+vendor+' '+renderer+' '+dims+' fps: '+inttostr(count);
count:=0;
end;

procedure TMform.TrackBar1Change(Sender: TObject);
begin
with panel1 do begin
matEm1[0]:=trackbar1.Position/255;
label5.Caption:=inttostr(trackbar1.Position);
end;
end;

procedure TMform.TrackBar2Change(Sender: TObject);
begin
with panel1 do begin
matEm1[1]:=trackbar2.Position/255;
label6.Caption:=inttostr(trackbar2.Position);
end;
end;

procedure TMform.TrackBar3Change(Sender: TObject);
begin
with panel1 do begin
matEm1[2]:=trackbar3.Position/255;
label7.Caption:=inttostr(trackbar3.Position);
end;
end;

procedure TMform.TrackBar4Change(Sender: TObject);
begin
with panel1 do begin
matAmb2[0]:=trackbar4.Position/255;
label8.Caption:=inttostr(trackbar4.Position);
end;
end;

procedure TMform.TrackBar5Change(Sender: TObject);
begin
with panel1 do begin
matAmb2[1]:=trackbar5.Position/255;
label9.Caption:=inttostr(trackbar5.Position);
end;
end;

procedure TMform.TrackBar6Change(Sender: TObject);
begin
with panel1 do begin
matAmb2[2]:=trackbar6.Position/255;
label10.Caption:=inttostr(trackbar6.Position);
end;
end;

procedure TMform.TrackBar7Change(Sender: TObject);
begin
with panel1 do begin
matDif2[0]:=trackbar7.Position/255;
label11.Caption:=inttostr(trackbar7.Position);
end;
end;

procedure TMform.TrackBar8Change(Sender: TObject);
begin
with panel1 do begin
matDif2[1]:=trackbar8.Position/255;
label12.Caption:=inttostr(trackbar8.Position);
end;
end;

procedure TMform.TrackBar9Change(Sender: TObject);
begin
with panel1 do begin
matDif2[2]:=trackbar9.Position/255;
label13.Caption:=inttostr(trackbar9.Position);
end;
end;

procedure TMform.TrackBar10Change(Sender: TObject);
begin
with panel1 do begin
matSpec2[0]:=trackbar10.Position/255;
label14.Caption:=inttostr(trackbar10.Position);
end;
end;

procedure TMform.TrackBar11Change(Sender: TObject);
begin
with panel1 do begin
matSpec2[1]:=trackbar11.Position/255;
label15.Caption:=inttostr(trackbar11.Position);
end;
end;

procedure TMform.TrackBar12Change(Sender: TObject);
begin
with panel1 do begin
matSpec2[2]:=trackbar12.Position/255;
label16.Caption:=inttostr(trackbar12.Position);
end;
end;

procedure TMform.TrackBar13Change(Sender: TObject);
begin
with panel1 do begin
shin:=trackbar13.Position;
label18.Caption:=inttostr(shin);
end;
end;

procedure TMform.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
rot:=true;
rvx:=0;rvy:=0;
inix:=x;
iniy:=y;
end;

procedure TMform.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var tmp:integer;
begin
if rot then
 begin
 rvx:=x-inix;
 rvy:=y-iniy;
 inix:=x;
 iniy:=y;
 tmp:=rvx; rvx:=rvy; rvy:=-tmp;
 glrotatef(2, rvx, rvy, 0);
 end;
end;

procedure TMform.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
rot:=false;
end;

end.
